;;!
;; A hodge-podge of utility functions
(module util mzscheme
	
	(require (lib "process.ss" "mzlib"))

	(provide maybe-make-directory
		 system-visible)

	;;!
	;; (contract Path -> #void)
	;; (signature (maybe-make-directory path))
	;;
	;; Make a directory if it doesn't already exist. Returns void
	;; on success and raises exn:i/o:filesystem otherwise
	(define (maybe-make-directory path)
	  (if (not (directory-exists? path))
	      (make-directory path)
	      (void)))


	;;!
	;; (contract String -> (union #t #f))
	;; (signature (system-command command) -> success)
	;;
	;; Execute a system command and inform the user of the result.
	;; Return the success or failure of the command
	(define (system-visible command)
	  (display command)
	  (newline)
	  (if (system command)
	      (begin (display "Succeeded") (newline) #t)
	      (begin (display "Failed") (newline) #f)))

	)